---
title: 'SUB RDD Technical Reference'

author:
- Software Quality Working Group
...



# Purpose

This guideline should help you getting started a new software
development project (or improving an existing one!) in the Research and
Development Department of the Göttingen State and University Library.\
Our goal is to establish better software quality by following standards
the developer team has mutually agreed upon. Roughly basing on the
[DARIAH Technical
Reference](https://dariah-eric.github.io/technical-reference/), these
standards are discussed, worked out, and decided in the Software Quality
Working Group, which meets biweekly on Tuesdays at 12:30-13:30. However,
they aren't cast in stone, so in case you have a good idea for a better
standard, feel free to contribute!


# Status

This document is a living document and will be extended as soon as the
Software Quality Working Group has agreed upon a new standard for
software projects in RDD.



# Guidelines

## Do you stick to our style guides?

The basic definitions are given by our [EditorConfig](http://editorconfig.org/),
i.e. unix line breaks and 2 space indentation.

For the more prominent programming languages we have formatting and
general style guides we ask you to follow:

-   **Java**: The style guide can be found
    [here](https://wiki.de.dariah.eu/download/attachments/64951939/FEGoogleStyle.xml?version=2&modificationDate=1522158497617&api=v2).
    It's based on the Google style guide for Java with some RDD specific
    setting. You can configure Eclipse to use it automatically at
    Eclipse &gt; Preferences &gt; Java &gt; Code Style &gt; Formatter.
-   **JavaScript**: For JS we use the [Airbnb JavaScript Style
    Guide](https://github.com/airbnb/javascript). @TODO: How to use in
    editor?
-   **HTML/CSS**: For HTML/CSS we agreed upon the [Google HTML/CSS Style
    Guide](https://google.github.io/styleguide/htmlcssguide.html). .
    @TODO: How to use in editor?
- 	**XQuery**: We use the [xqdoc style guide](http://xqdoc.org/xquery-style.pdf) with the following addenda:
	- use double quotes instead of single quotes

-   **XSLT**: @TODO
-   **SPARQL**: @TODO

